Index: palm/trunk/SCRIPTS/NCL/profiles.ncl
===================================================================
--- palm/trunk/SCRIPTS/NCL/profiles.ncl	(revision 157)
+++ palm/trunk/SCRIPTS/NCL/profiles.ncl	(revision 161)
@@ -10,5 +10,5 @@
 
    if (isfilepresent("~/.ncl_preferences")) then
-      parameter = asciiread("~/.ncl_preferences",73,"string")
+      parameter = asciiread("~/.ncl_preferences",75,"string")
       delete(parameter@_FillValue)
    else
@@ -71,6 +71,10 @@
    if (combine .EQ. 1) then
       if( .not. isvar("c_var") ) then
-         c_var=" "
-         if (parameter(27) .NE. "c_variables") then
+         if (parameter(27) .EQ. "c_variables") then
+            print(" ") 
+            print("Please select variables for overlaying ('c_var')")
+            print(" ")
+            exit
+         else
             c_var=parameter(27)
          end if
@@ -101,5 +105,17 @@
       end if
    end if
-
+   if ( .not. isvar("over") ) then     		        ; switches overlaying plots on
+      over = 0
+      if (stringtointeger(parameter(73)) .NE. 0) then
+         over = stringtointeger(parameter(73))
+         if (stringtointeger(parameter(73)) .NE. 1) then
+            print(" ")
+            print("Please set 'over' to 0 or 1")
+            print(" ")
+            exit
+         end if   
+      end if
+   end if
+  
    ; ***************************************************
    ; open input file
@@ -108,14 +124,342 @@
    f=addfile( file_in,"r")
    
-   vNam  = getfilevarnames(f) 
+   vNam = getfilevarnames(f) 
    print(" ")
    print("Variable on netCDF file: " + vNam)
    print(" ")
-   dim   = dimsizes(vNam)
-   z_pr  = f->zpt
-   dimz  = dimsizes(z_pr)
+   dim = dimsizes(vNam)
+   if (dim .EQ. 0) then
+      print(" ")
+      print("There are no data on file")
+      print(" ")
+   end if
+
+   do varn = dim-1,0,1
+      if ( isStrSubset( vNam(varn), "time") .OR. isStrSubset( vNam(varn), "NORM")) then
+         varn=varn-1
+         continue
+      end if
+      if (vNam(varn) .EQ. "u")
+         z_u = f->zu
+         break
+      else
+         if (vNam(varn) .EQ. "v")then
+            z_u = f->zv
+            break
+         else
+            if(vNam(varn) .EQ. "pt")then
+               z_u = f->zpt
+               break
+            else
+               if(vNam(varn) .EQ. "vpt")then
+                  z_u = f->zvpt 
+                  break
+               else
+                  if(vNam(varn) .EQ. "lpt")then
+                     z_u = f->zlpt 
+                     break
+                  else   
+                     if(vNam(varn) .EQ. "q")then
+                        z_u = f->zq 
+                        break
+                     else
+                        if(vNam(varn) .EQ. "qv")then
+                           z_u = f->zqv 
+                           break
+                        else
+                           if(vNam(varn) .EQ. "ql")then
+                              z_u = f->zql 
+                              break
+                           else
+                              if(vNam(varn) .EQ. "rho")then
+                                 z_u = f->zrho 
+                                 break
+                              else
+                                 if(vNam(varn) .EQ. "s")then
+                                    z_u = f->zs 
+                                    break
+                                 else
+                                    if(vNam(varn) .EQ. "sa")then
+                                       z_u = f->zsa 
+                                       break
+                                    else
+                                       if(vNam(varn) .EQ. "e")then
+                                          z_u = f->ze 
+                                          break
+                                       else
+                                          if(vNam(varn) .EQ. "es")then
+                                             z_u = f->zes 
+                                             break
+                                          else
+                                             if(vNam(varn) .EQ. "km")then
+                                                z_u = f->zkm 
+                                                break
+                                             else
+                                                if(vNam(varn) .EQ. "kh")then
+                                                   z_u = f->zkh 
+                                                   break
+                                                else
+                                                   if(vNam(varn) .EQ. "l")then
+                                                      z_u = f->zl 
+                                                      break
+                                                   else
+                                                      if(vNam(varn) .EQ. "us2")then
+                                                         z_u = f->zus2 
+                                                         break
+                                                      else
+                                                         if(vNam(varn) .EQ. "vs2")then
+                                                            z_u = f->zvs2 
+                                                            break
+                                                         else
+                                                            if(vNam(varn) .EQ. "pts2")then
+                                                               z_u = f->zpts2 
+                                                               break
+                                                            else
+                                                               if(vNam(varn) .EQ. "wsususodz")then
+                                                                  z_u = f->zwsususodz 
+                                                                  break
+                                                               else
+                                                                  if(vNam(varn) .EQ. "wspsodz")then
+                                                                     z_u = f->zwspsodz 
+                                                                     break
+                                                                  else
+                                                                     if(vNam(varn) .EQ. "wpeodz")then
+                                                                        z_u = f->zwpeodz
+                                                                        break                                                                        
+                                                                     end if
+                                                                  end if
+                                                               end if
+                                                            end if
+                                                         end if
+                                                      end if
+                                                   end if
+                                                end if
+                                             end if
+                                          end if
+                                       end if
+                                    end if
+                                 end if
+                              end if
+                           end if
+                        end if
+                     end if
+                  end if
+               end if
+            end if 
+         end if
+      end if
+      varn=varn-1
+   end do
+
+   do varn=dim-1,0,1
+      if ( isStrSubset( vNam(varn), "time") .OR. isStrSubset( vNam(varn), "NORM")) then
+         varn=varn-1
+         continue
+      end if 
+      if (vNam(varn) .EQ. "w")
+         z_w = f->zw
+         break
+      else
+         if (vNam(varn) .EQ. "wpup")then
+            z_w = f->zwpup
+            break
+         else
+            if(vNam(varn) .EQ. "wsus")then
+               z_w = f->zwsus
+               break
+            else
+               if(vNam(varn) .EQ. "wu")then
+                  z_w = f->zwu 
+                  break
+               else
+                  if(vNam(varn) .EQ. "wpvp")then
+                     z_w = f->zwpvp 
+                     break
+                  else   
+                     if(vNam(varn) .EQ. "wsvs")then
+                        z_w = f->zwsvs 
+                        break
+                     else
+                        if(vNam(varn) .EQ. "wv")then
+                           z_w = f->zwv 
+                           break
+                        else
+                           if(vNam(varn) .EQ. "wptpp")then
+                              z_w = f->zwptpp 
+                              break
+                           else
+                              if(vNam(varn) .EQ. "wspts")then
+                                 z_w = f->zwspts 
+                                 break
+                              else
+                                 if(vNam(varn) .EQ. "wpt")then
+                                    z_w = f->zwpt
+                                    break
+                                 else
+                                    if(vNam(varn) .EQ. "wsptsBC")then
+                                       z_w = f->zwsptsBC 
+                                       break
+                                    else
+                                       if(vNam(varn) .EQ. "wptBC")then
+                                          z_w = f->zwptBC 
+                                          break
+                                       else
+                                          if(vNam(varn) .EQ. "wpvptp")then
+                                             z_w = f->zwpvptp 
+                                             break
+                                          else
+                                             if(vNam(varn) .EQ. "wsvpts")then
+                                                z_w = f->zwsvpts
+                                                break
+                                             else
+                                                if(vNam(varn) .EQ. "wvpt")then
+                                                   z_w = f->zwvpt 
+                                                   break
+                                                else
+                                                   if(vNam(varn) .EQ. "wpqp")then
+                                                      z_w = f->zwpqp 
+                                                      break
+                                                   else
+                                                      if(vNam(varn) .EQ. "wsqs")then
+                                                         z_w = f->zwsqs 
+                                                         break
+                                                      else
+                                                         if(vNam(varn) .EQ. "wq")then
+                                                            z_w = f->zwq 
+                                                            break
+                                                         else
+                                                            if(vNam(varn) .EQ. "wpqvp")then
+                                                               z_w = f->zwpqvp 
+                                                               break
+                                                            else
+                                                               if(vNam(varn) .EQ. "wsqvs")then
+                                                                  z_w = f->zwsqvs 
+                                                                  break
+                                                               else
+                                                                  if(vNam(varn) .EQ. "wqv")then
+                                                                     z_w = f->zwqv 
+                                                                     break
+                                                                  else
+                                                                     if(vNam(varn) .EQ. "wpsp")then
+                                                                        z_w = f->zwpsp
+                                                                        break 
+                                                                     else
+                                                                        if(vNam(varn) .EQ. "wsss")then
+                                                                           z_w = f->zwsss
+                                                                           break 
+                                                                        else
+                                                                           if(vNam(varn) .EQ. "ws")then
+                                                                              z_w = f->zws
+                                                                              break 
+                                                                           else
+                                                                              if(vNam(varn) .EQ. "wpsap")then
+                                                                                 z_w = f->zwpsap
+                                                                                 break 
+                                                                              else
+                                                                                 if(vNam(varn) .EQ. "wssas")then
+                                                                                    z_w = f->zwssas
+                                                                                    break 
+                                                                                 else
+                                                                                    if(vNam(varn) .EQ. "wsa")then
+                                                                                       z_w = f->zwsa
+                                                                                       break 
+                                                                                    else
+                                                                                       if(vNam(varn) .EQ. "wses")then
+                                                                                          z_w = f->zwses
+                                                                                          break 
+                                                                                       else
+                                                                                          if(vNam(varn) .EQ. "ws2")then
+                                                                                             z_w = f->zws2
+                                                                                             break 
+                                                                                          else
+                                                                                             if(vNam(varn) .EQ. "ws3")then
+                                                                                                z_w = f->zws3
+                                                                                                break 
+                                                                                             else
+                                                                                                if(vNam(varn) .EQ. "Sw")then
+                                                                                                   z_w = f->zSw
+                                                                                                   break 
+                                                                                                else
+                                                                                                   if(vNam(varn) .EQ. "ws2pts")then
+                                                                                                      z_w = f->zws2pts
+                                                                                                      break 
+                                                                                                   else
+                                                                                                      if(vNam(varn) .EQ. "wspts2")then
+                                                                                                         z_w = f->zwspts2
+                                                                                                         break                                            
+                                                                                                      end if
+                                                                                                   end if 
+                                                                                                end if
+                                                                                             end if
+                                                                                          end if
+                                                                                       end if
+                                                                                    end if
+                                                                                 end if
+                                                                              end if
+                                                                           end if
+                                                                        end if    
+                                                                     end if
+                                                                  end if
+                                                               end if
+                                                            end if
+                                                         end if
+                                                      end if
+                                                   end if
+                                                end if
+                                             end if
+                                          end if
+                                       end if
+                                    end if
+                                 end if
+                              end if
+                           end if
+                        end if
+                     end if
+                  end if
+               end if
+            end if 
+         end if
+      end if
+      varn=varn-1
+   end do
+   if ( .not. isvar("z_u") ) then
+      zu = 0
+   else
+      zu = 1
+   end if
+   if ( .not. isvar("z_w") ) then
+      zw = 0
+   else 
+      zw = 1
+   end if
+
+   if (zu .EQ. 0 .AND. zw .EQ. 0) then
+      do varn=0,dim-1      
+         if ( isStrSubset( vNam(varn), "time") .OR. isStrSubset( vNam(varn), "NORM")) then
+            check = False
+         else
+            if (.not. isvar("var")) then
+               check = True
+               if (parameter(21) .NE. "variables") then
+                  var=parameter(21)
+                  check = isStrSubset( var,","+vNam(varn)+"," )
+               end if
+            else          
+               check = isStrSubset( var,","+vNam(varn)+"," )
+            end if
+         end if
+         if (check)
+            z = f->$vNam(varn+1)$
+            dimz = dimsizes(z)
+            break
+         end if   
+      end do
+   end if
+ 
+   dimz  = dimsizes(z_w)
+   dimz  = dimsizes(z_u)
    t_all = f->time
    nt    = dimsizes(t_all)
-
+ 
    ; ****************************************************	
    ; start of time step and different types of mistakes that could be done
@@ -125,7 +469,7 @@
       start_time_step = 1
       if (parameter(13) .NE. "1") then
-         if (parameter(13) .LE. "0")
-            print(" ")
-            print("Begin with time step 1")
+         if (parameter(13) .LE. "1")
+            print(" ")
+            print("Begin at least with time step 2")
             print(" ")
             exit
@@ -137,10 +481,10 @@
             exit
          end if
-         start_time_step = stringtointeger(parameter(13))  
+         start_time_step = stringtointeger(parameter(13))-1  
       end if
    else 
       if (start_time_step .LE. 0)
          print(" ")
-         print("Begin with time step 1")
+         print("Begin at least with time step 1")
          print(" ")
          exit
@@ -152,4 +496,5 @@
          exit
       end if
+      start_time_step = start_time_step - 1 
    end if
 
@@ -200,4 +545,5 @@
             exit
       end if
+      end_time_step = end_time_step - 1
    end if
 
@@ -206,5 +552,5 @@
    ; ****************************************************
    
-   legend_label=new(nt-1,double)
+   legend_label=new(nt,double)
    do p=start_time_step,end_time_step
       legend_label(p-start_time_step)=t_all(p)
@@ -224,5 +570,4 @@
    res@gsnFrame                = False
    res@gsnPaperOrientation     = "portrait"
-   ;  res@gsnmaximize             = True
    res@gsnPaperWidth           = 8.27
    res@gsnPaperHeight          = 11.69
@@ -239,11 +584,15 @@
    res@pmLegendSide            = "Top"
    res@xyExplicitLegendLabels  = legend_label
-   res@pmLegendParallelPosF    = 1.4
-   res@pmLegendOrthogonalPosF  = -1.085
+   res@pmLegendParallelPosF    = 1.15
+   res@pmLegendOrthogonalPosF  = -1.0
    res@pmLegendWidthF          = 0.12
    res@pmLegendHeightF         = 0.3
    res@lgLabelFontHeightF     = .02 
-   ;  res@XBLabelConstantSpacingF = 1.0
-
+   res@txFontHeightF      = 0.02
+   res@tiXAxisFontHeightF = 0.02
+   res@tiYAxisFontHeightF = 0.02
+   res@tiXAxisString      = " "    
+   res@tiYAxisString      = "Height [z]"
+   
    if ( dash .eq. 0 ) then
       res@xyMonoDashPattern       = True  
@@ -257,66 +606,36 @@
 
    ; ***************************************************
-   ; set up colors and recourses for combined plot
-   ; ***************************************************
-   
-   if (combine .EQ. 1) then
-
-      if (.not. isvar("number_comb")) then
-         m=0
-         m=stringtointeger(parameter(25))
-         if(m .EQ. 0) then
-            print(" ")
-            print("Please indicate the number of variables you would like to combine ('number_comb')")
-            print(" ")
-            exit
-         end if
-      end if
-    
-      ores=True
-      
-      colors=new(m*(nt-1),integer)
-      do j=0,m-1
-         colors(j+j*(nt-2):(j+1)*(nt-1)-1) = ispan(2,237,235/np)
-      end do   
-      ores@xyLineColors = colors
-
-      dash_oplot=new(m*(nt-1),integer)
-      do j=0,m-1
-         dash_oplot(j+j*(nt-2):(j+1)*(nt-1)-1)=j
-      end do
-      ores@xyDashPatterns = dash_oplot
-
-      ores                         = True
-      ores@gsnDraw                 = False
-      ores@gsnFrame                = False
-      ores@gsnPaperOrientation     = "portrait"
-      ;  ores@gsnmaximize             = True
-      ores@gsnPaperWidth           = 8.27
-      ores@gsnPaperHeight          = 11.69
-      ores@gsnPaperMargin          = 0.79
-      ores@txFont                  = "helvetica"
-      ores@tiMainFont              = "helvetica"
-      ores@tiXAxisFont             = "helvetica"
-      ores@tiYAxisFont             = "helvetica"
-      ores@tmXBLabelFont           = "helvetica"
-      ores@tmYLLabelFont           = "helvetica"
-      ores@lgLabelFont             = "helvetica"
-      ores@tmLabelAutoStride       = True
-      ores@pmLegendDisplayMode     = "Always"
-      ores@pmLegendSide            = "Top"
-      ores@pmLegendParallelPosF    = 1.4
-      ores@pmLegendOrthogonalPosF  = -1.085
-      ores@pmLegendWidthF          = 0.15
-      ores@pmLegendHeightF         = 0.60
-      ores@lgLabelFontHeightF     = .02 
-      ;  ores@XBLabelConstantSpacingF = 1.0
- 
-   end if
-
-   ; ***************************************************
    ; set up graphics for plot
    ; ***************************************************
 
-   plot  = new(dim,graphic)
+   plot = new(dim,graphic)
+   plot_ = new(dim,graphic)
+
+   if (combine .EQ. 1) then
+      if ( .not. isvar("number_comb") ) then        	
+         if (parameter(25) .EQ. "0") then
+            print(" ")
+            print("Please set 'number_comb' to 2 or 3 if you would like to overlay 2 or 3 variables in one plot")
+            print(" ")
+            exit
+         else
+            number_comb=stringtointeger(parameter(25))
+            plot_o = new(number_comb,graphic)   
+         end if
+      else
+         if(number_comb .EQ. 2 .OR. number_comb .EQ. 3) then
+            plot_o = new(number_comb,graphic)     
+         else
+            print(" ")
+            print("Please set 'number_comb' to 2 or 3 if you would like to overlay 2 or 3 variables in one plot")
+            print(" ")
+            exit 
+         end if    
+      end if
+      label=new(number_comb,string)
+      color_o=new(number_comb,integer)
+      mini=new(number_comb,float)
+      maxi=new(number_comb,float)
+   end if
 
    wks=gsn_open_wks(format_out,file_out)
@@ -324,13 +643,13 @@
  
    ; ***************************************************
-   ; indicate plot number
+   ; indicate plot number 
    ; ***************************************************
-
+   
    if (combine .EQ. 1) then
-      n = 1 
+      n = 1
    else
       n = 0
-   end if 
-  
+   end if
+
    ; ***************************************************
    ; set up minimum and maximum height
@@ -340,7 +659,7 @@
       min_z=0
       if (stringtointeger(parameter(33)) .NE. 0) then
-         if (stringtointeger(parameter(33)) .GE. max(z_pr) ) then
-            print(" ")
-            print("Minimum of height ('min_z'="+stringtointeger(parameter(33))+") is greater than available heights (="+max(z_pr)+")")
+         if (stringtointeger(parameter(33)) .GE. max(z_u) ) then
+            print(" ")
+            print("Minimum of height ('min_z'="+stringtointeger(parameter(33))+") is greater than available heights (="+max(z_u)+")")
             print(" ")
             exit
@@ -355,7 +674,7 @@
       end if
    else
-      if (min_z .GE. max(z_pr) ) then
+      if (min_z .GE. max(z_u) ) then
          print(" ")
-         print("Minimum of height ('min_z'="+min_z+") is greater than available heights (="+max(z_pr)+")")
+         print("Minimum of height ('min_z'="+min_z+") is greater than available heights (="+max(z_u)+")")
          print(" ")
          exit
@@ -370,9 +689,9 @@
 
    if (.not. isvar("max_z"))
-      max_z=max(z_pr)
-      if ((parameter(35)) .NE. "max(z_pr)") then
-         if (stringtofloat(parameter(35)) .GE. max(z_pr) ) then
-            print(" ")
-            print("Maximum of height ('max_z'="+parameter(35)+") is greater than available heights (="+max(z_pr)+")")
+      max_z=max(z_u)
+      if ((parameter(35)) .NE. "max(z_u)") then
+         if (stringtofloat(parameter(35)) .GE. max(z_u) ) then
+            print(" ")
+            print("Maximum of height ('max_z'="+parameter(35)+") is greater than available heights (="+max(z_u)+")")
             print(" ")
             exit
@@ -389,5 +708,5 @@
       if (max_z .GE. max(z_pr) ) then
          print(" ")
-         print("Maximum of height ('max_z'="+max_z+") is greater than available heights (="+max(z_pr)+")")
+         print("Maximum of height ('max_z'="+max_z+") is greater than available heights (="+max(z_u)+")")
          print(" ")
          exit
